VTK: RTW::Object Class Reference

| VTK 9.0.1

Public Member Functions | Protected Member Functions | List of all members
RTW::Object Class Referenceabstract

`#include <Object.h>`

Inheritance diagram for RTW::Object:
[legend]

## Public Member Functions
| Object ()
virtual | ~Object ()
virtual void | Commit ()=0
void | AddRef ()
void | Release ()
void | SetString (const std::string &id, const std::string &s)
const std::string | GetString (const std::vector< std::string > &ids, const std::string &defaultValue="", bool *found=nullptr) const
bool | GetString (const std::vector< std::string > &ids, std::string *result, const std::string &defaultValue=nullptr)
template<typename T = Object>
void | SetObject (const std::string &id, T *object)
template<typename T = Object>
T * | GetObject (const std::vector< std::string > &ids, T *defaultValue=nullptr, bool *found=nullptr) const
template<typename T = Object>
bool | GetObject (const std::vector< std::string > &ids, T **result, T *defaultValue=nullptr)
void | Set1i (const std::string &id, int32_t x)
int32_t | Get1i (const std::vector< std::string > &ids, int32_t defaultValue=0, bool *found=nullptr) const
bool | Get1i (const std::vector< std::string > &ids, int32_t *result, int32_t defaultValue=0)
void | Set1f (const std::string &id, float x)
float | Get1f (const std::vector< std::string > &ids, float defaultValue=0.0f, bool *found=nullptr) const
bool | Get1f (const std::vector< std::string > &ids, float *result, float defaultValue=0.0f)
void | Set2i (const std::string &id, int32_t x, int32_t y)
VisRTX::Vec2i | Get2i (const std::vector< std::string > &ids, const VisRTX::Vec2i &defaultValue=VisRTX::Vec2i(), bool *found=nullptr) const
bool | Get2i (const std::vector< std::string > &ids, VisRTX::Vec2i *result, const VisRTX::Vec2i &defaultValue=VisRTX::Vec2i())
void | Set2f (const std::string &id, float x, float y)
VisRTX::Vec2f | Get2f (const std::vector< std::string > &ids, const VisRTX::Vec2f &defaultValue=VisRTX::Vec2f(), bool *found=nullptr) const
bool | Get2f (const std::vector< std::string > &ids, VisRTX::Vec2f *result, const VisRTX::Vec2f &defaultValue=VisRTX::Vec2f())
void | Set3i (const std::string &id, int32_t x, int32_t y, int32_t z)
VisRTX::Vec3i | Get3i (const std::vector< std::string > &ids, const VisRTX::Vec3i &defaultValue=VisRTX::Vec3i(), bool *found=nullptr) const
bool | Get3i (const std::vector< std::string > &ids, VisRTX::Vec3i *result, const VisRTX::Vec3i &defaultValue=VisRTX::Vec3i())
void | Set3f (const std::string &id, float x, float y, float z)
VisRTX::Vec3f | Get3f (const std::vector< std::string > &ids, const VisRTX::Vec3f &defaultValue=VisRTX::Vec3f(), bool *found=nullptr) const
bool | Get3f (const std::vector< std::string > &ids, VisRTX::Vec3f *result, const VisRTX::Vec3f &defaultValue=VisRTX::Vec3f())
void | Set4f (const std::string &id, float x, float y, float z, float w)
VisRTX::Vec4f | Get4f (const std::vector< std::string > &ids, const VisRTX::Vec4f &defaultValue=VisRTX::Vec4f(), bool *found=nullptr) const
bool | Get4f (const std::vector< std::string > &ids, VisRTX::Vec4f *result, const VisRTX::Vec4f &defaultValue=VisRTX::Vec4f())
void | RemoveParam (const std::string &id)

## Protected Member Functions
void | PrintAllParameters () const
std::set< std::string > | GetAllParameters () const

## Detailed Description

Definition at line 17 of file Object.h.

## Constructor & Destructor Documentation

## ◆ Object()

RTW::Object::Object | ( |  | ) |
| inline

Definition at line 20 of file Object.h.

## ◆ ~Object()

virtual RTW::Object::~Object | ( |  | ) |
| inlinevirtual

Definition at line 25 of file Object.h.

## Member Function Documentation

## ◆ Commit()

virtual void RTW::Object::Commit | ( |  | ) |
| pure virtual

Implemented in RTW::Data, RTW::Material, RTW::Texture, RTW::Light, RTW::Geometry, RTW::Camera, RTW::FrameBuffer, RTW::Renderer, and RTW::Model.

## ◆ AddRef()

void RTW::Object::AddRef | ( |  | ) |
| inline

Definition at line 36 of file Object.h.

## ◆ Release()

void RTW::Object::Release | ( |  | ) |
| inline

Definition at line 41 of file Object.h.

## ◆ SetString()

void RTW::Object::SetString | ( | const std::string & | id,
|  | const std::string & | s
| ) |  |
| inline

Definition at line 51 of file Object.h.

## ◆ GetString() [1/2]

const std::string RTW::Object::GetString | ( | const std::vector< std::string > & | ids,
|  | const std::string & | defaultValue = `""`,
|  | bool * | found = `nullptr`
| ) |  | const
| inline

Definition at line 56 of file Object.h.

## ◆ GetString() [2/2]

bool RTW::Object::GetString | ( | const std::vector< std::string > & | ids,
|  | std::string * | result,
|  | const std::string & | defaultValue = `nullptr`
| ) |  |
| inline

Definition at line 61 of file Object.h.

## ◆ SetObject()

template<typename T = Object>

void RTW::Object::SetObject | ( | const std::string & | id,
|  | T * | object
| ) |  |
| inline

Definition at line 69 of file Object.h.

## ◆ GetObject() [1/2]

template<typename T = Object>

T* RTW::Object::GetObject | ( | const std::vector< std::string > & | ids,
|  | T * | defaultValue = `nullptr`,
|  | bool * | found = `nullptr`
| ) |  | const
| inline

Definition at line 89 of file Object.h.

## ◆ GetObject() [2/2]

template<typename T = Object>

bool RTW::Object::GetObject | ( | const std::vector< std::string > & | ids,
|  | T ** | result,
|  | T * | defaultValue = `nullptr`
| ) |  |
| inline

Definition at line 95 of file Object.h.

## ◆ Set1i()

void RTW::Object::Set1i | ( | const std::string & | id,
|  | int32_t | x
| ) |  |
| inline

Definition at line 102 of file Object.h.

## ◆ Get1i() [1/2]

int32_t RTW::Object::Get1i | ( | const std::vector< std::string > & | ids,
|  | int32_t | defaultValue = `0`,
|  | bool * | found = `nullptr`
| ) |  | const
| inline

Definition at line 107 of file Object.h.

## ◆ Get1i() [2/2]

bool RTW::Object::Get1i | ( | const std::vector< std::string > & | ids,
|  | int32_t * | result,
|  | int32_t | defaultValue = `0`
| ) |  |
| inline

Definition at line 112 of file Object.h.

## ◆ Set1f()

void RTW::Object::Set1f | ( | const std::string & | id,
|  | float | x
| ) |  |
| inline

Definition at line 119 of file Object.h.

## ◆ Get1f() [1/2]

float RTW::Object::Get1f | ( | const std::vector< std::string > & | ids,
|  | float | defaultValue = `0.0f`,
|  | bool * | found = `nullptr`
| ) |  | const
| inline

Definition at line 124 of file Object.h.

## ◆ Get1f() [2/2]

bool RTW::Object::Get1f | ( | const std::vector< std::string > & | ids,
|  | float * | result,
|  | float | defaultValue = `0.0f`
| ) |  |
| inline

Definition at line 129 of file Object.h.

## ◆ Set2i()

void RTW::Object::Set2i | ( | const std::string & | id,
|  | int32_t | x,
|  | int32_t | y
| ) |  |
| inline

Definition at line 136 of file Object.h.

## ◆ Get2i() [1/2]

VisRTX::Vec2i RTW::Object::Get2i | ( | const std::vector< std::string > & | ids,
|  | const VisRTX::Vec2i & | defaultValue = `VisRTX::Vec2i()`,
|  | bool * | found = `nullptr`
| ) |  | const
| inline

Definition at line 141 of file Object.h.

## ◆ Get2i() [2/2]

bool RTW::Object::Get2i | ( | const std::vector< std::string > & | ids,
|  | VisRTX::Vec2i * | result,
|  | const VisRTX::Vec2i & | defaultValue = `VisRTX::Vec2i()`
| ) |  |
| inline

Definition at line 146 of file Object.h.

## ◆ Set2f()

void RTW::Object::Set2f | ( | const std::string & | id,
|  | float | x,
|  | float | y
| ) |  |
| inline

Definition at line 153 of file Object.h.

## ◆ Get2f() [1/2]

VisRTX::Vec2f RTW::Object::Get2f | ( | const std::vector< std::string > & | ids,
|  | const VisRTX::Vec2f & | defaultValue = `VisRTX::Vec2f()`,
|  | bool * | found = `nullptr`
| ) |  | const
| inline

Definition at line 158 of file Object.h.

## ◆ Get2f() [2/2]

bool RTW::Object::Get2f | ( | const std::vector< std::string > & | ids,
|  | VisRTX::Vec2f * | result,
|  | const VisRTX::Vec2f & | defaultValue = `VisRTX::Vec2f()`
| ) |  |
| inline

Definition at line 163 of file Object.h.

## ◆ Set3i()

void RTW::Object::Set3i | ( | const std::string & | id,
|  | int32_t | x,
|  | int32_t | y,
|  | int32_t | z
| ) |  |
| inline

Definition at line 170 of file Object.h.

## ◆ Get3i() [1/2]

VisRTX::Vec3i RTW::Object::Get3i | ( | const std::vector< std::string > & | ids,
|  | const VisRTX::Vec3i & | defaultValue = `VisRTX::Vec3i()`,
|  | bool * | found = `nullptr`
| ) |  | const
| inline

Definition at line 175 of file Object.h.

## ◆ Get3i() [2/2]

bool RTW::Object::Get3i | ( | const std::vector< std::string > & | ids,
|  | VisRTX::Vec3i * | result,
|  | const VisRTX::Vec3i & | defaultValue = `VisRTX::Vec3i()`
| ) |  |
| inline

Definition at line 180 of file Object.h.

## ◆ Set3f()

void RTW::Object::Set3f | ( | const std::string & | id,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |
| inline

Definition at line 187 of file Object.h.

## ◆ Get3f() [1/2]

VisRTX::Vec3f RTW::Object::Get3f | ( | const std::vector< std::string > & | ids,
|  | const VisRTX::Vec3f & | defaultValue = `VisRTX::Vec3f()`,
|  | bool * | found = `nullptr`
| ) |  | const
| inline

Definition at line 192 of file Object.h.

## ◆ Get3f() [2/2]

bool RTW::Object::Get3f | ( | const std::vector< std::string > & | ids,
|  | VisRTX::Vec3f * | result,
|  | const VisRTX::Vec3f & | defaultValue = `VisRTX::Vec3f()`
| ) |  |
| inline

Definition at line 197 of file Object.h.

## ◆ Set4f()

void RTW::Object::Set4f | ( | const std::string & | id,
|  | float | x,
|  | float | y,
|  | float | z,
|  | float | w
| ) |  |
| inline

Definition at line 204 of file Object.h.

## ◆ Get4f() [1/2]

VisRTX::Vec4f RTW::Object::Get4f | ( | const std::vector< std::string > & | ids,
|  | const VisRTX::Vec4f & | defaultValue = `VisRTX::Vec4f()`,
|  | bool * | found = `nullptr`
| ) |  | const
| inline

Definition at line 209 of file Object.h.

## ◆ Get4f() [2/2]

bool RTW::Object::Get4f | ( | const std::vector< std::string > & | ids,
|  | VisRTX::Vec4f * | result,
|  | const VisRTX::Vec4f & | defaultValue = `VisRTX::Vec4f()`
| ) |  |
| inline

Definition at line 214 of file Object.h.

## ◆ RemoveParam()

void RTW::Object::RemoveParam | ( | const std::string & | id | ) |
| inline

Definition at line 221 of file Object.h.

## ◆ PrintAllParameters()

void RTW::Object::PrintAllParameters | ( |  | ) | const
| inlineprotected

Definition at line 235 of file Object.h.

## ◆ GetAllParameters()

std::set<std::string> RTW::Object::GetAllParameters | ( |  | ) | const
| inlineprotected

Definition at line 265 of file Object.h.

The documentation for this class was generated from the following file:

- Rendering/RayTracing/RTWrapper/VisRTX/Object.h